View Issue Details

IDProjectCategoryView StatusLast Update
0016521MediaMonkey 5Synchronizationpublic2020-06-08 15:24
ReporterLudek Assigned To 
PriorityurgentSeverityfeatureReproducibilityalways
Status resolvedResolutionreopened 
Product Version5.0 
Target Version5.0.1Fixed in Version5.0 
Summary0016521: Spotify addon for syncing playlists
DescriptionSpotify already has "Web API" that allows manipulating the content:
https://developer.spotify.com/documentation/web-api/reference/

This REST api could be used similar (but more limited) way as others cloud services currently integrated in MM5 (OneDrive, Google Play Music, Google Drive, DropBox).
Additional Informationhttps://www.mediamonkey.com/forum/viewtopic.php?f=27&t=89742

Registering console app: https://developer.spotify.com/documentation/general/guides/app-settings/#register-your-app
TagsNo tags attached.
Fixed in build2256

Activities

Ludek

2020-04-17 11:45

developer   ~0057618

Set target to 5.0 to triage how easy is the intergration.

Ludek

2020-04-17 20:09

developer   ~0057628

Last edited: 2020-04-17 20:26

View 4 revisions

Added Spotify sample script to /SampleScripts/ folder in 2242.

It can browse user's Spotify playlists, browse playlists content and play 30 seconds previews of the playlist tracks in MM5.

TODOs: Syncing playlists + full playback of tracks (if possible)

Ludek

2020-04-18 20:58

developer   ~0057637

Last edited: 2020-04-18 21:07

View 2 revisions

In build 2243: Added support for scanning Spotify playlists into DB (under Spotify parent playlist) + Fixed: listing limited to 20 playlists

Ludek

2020-04-26 18:04

developer   ~0057753

Last edited: 2020-04-26 18:06

View 3 revisions

Added MM5 > Spotify playlists sync in build 2244.

So playlists can be synced in both directions now:
- Spotify playlists are scanned o [MM5 > Playlists > Spotify]
- MM5 playlists are synced to Spotify library (the already existing playlists that were not created by MM5 are left untouched until all tracks are matched)


Possible future improvements:
1) full playback of Spotify tracks (those unmatched) in MM, this would be limited anyhow as it requires using web playback SDK api: https://developer.spotify.com/documentation/web-playback-sdk/ + is allowed only for premium users and with further restritions described in Spotify's terms of use.
Currently unmatched tracks plays only the 30 seconds preview when played via MM5.
2) Sync of favorite artists ?
3) Sync of favorite albums ?

peke

2020-05-20 23:21

developer   ~0058154

reopen new log supplied C491F22F https://www.mediamonkey.com/forum/viewtopic.php?p=468444#p468444

Ludek

2020-05-21 13:15

developer   ~0058159

Last edited: 2020-05-22 11:08

View 2 revisions

Fixed in 2251

Ludek

2020-05-22 09:27

developer   ~0058181

Last edited: 2020-05-22 09:27

View 2 revisions

Re-opened: Scan still crashes on some "broken" playlists like https://open.spotify.com/playlist/4173ENNA5eMzHrz9pipvxI
Crashes: A04CA4BC and similar

Ludek

2020-05-22 11:56

developer   ~0058183

Fixed in 2251

Ludek

2020-05-25 20:01

developer   ~0058270

Improved the matching algorithm in 2252

Ludek

2020-06-05 18:15

developer   ~0058457

Improved the matching process further in 2256

So that:
'High Hopes - 2011 Remaster' matches 'High Hopes'
'A New Machine (Pt. 1) - 2019' matches 'New Machine, Pt. 1'

Ludek

2020-06-08 15:24

developer   ~0058465

Further improvements in 2256:
- fixed some possible crashes
- improved matching (Rachel's stuff) -- #UUF-246-80955
- fixed error on uploading of not-owned playlists
- fixed "file is inaccessible" errors when matching MM5 tracks to Spotify